//Bibliothek zum ansteuern von NeoPixel / RGB LED-Stripes.
#include <Adafruit_NeoPixel.h>

//Die RGB Stripe ist am digitalen Pin D2 angeschlossen.
#define PIXELPIN 2
//Die RGB Stripe hat 16 NeoPixel / LEDs.
#define NUMPIXELS 16

//Der Bewegungssensor ist am digitalen Pin D3 angeschlossen.
#define SENSOR 3

//Initialisieren eines Objektes vom Typ Adafruit_NeoPixel
Adafruit_NeoPixel pixels(NUMPIXELS, PIXELPIN, NEO_GRB + NEO_KHZ800);

//Definieren der Farben, mit RGB Werten
const uint32_t COLOR_WHITE = pixels.Color(255, 255, 255);
const uint32_t COLOR_RED = pixels.Color(107, 10, 10);

void setup() {
  //Begin der kommunikation mit dem NeoPixel
  pixels.begin();
  //Definieren das der Pin des Bewegungssensors als Eingang dient.
  pinMode(SENSOR, INPUT);
}

void loop() {
  //Wenn der Pin des Sensors HIGH ist, dann...
  if (digitalRead(SENSOR) == HIGH) {
    //löschen der derzeit angezeigten Farben
    pixels.clear();
    //Schleife von 0 bis 15,...
    for (int i = 0; i < NUMPIXELS; i++) {
      //default Farbe ist Weiß
      uint32_t color = COLOR_WHITE;
      //Wenn das Ergebnis der Operation i modulo 3 ohne Rest ist, dann...
      if ((i % 3) == 0) {
        //ändern der Farbe auf Rot
        color = COLOR_RED;
      }
      //Zuweisen der Farbe zu einem NeoPixel
      pixels.setPixelColor(i, color);
    }
    //Anzeigen der Farben
    pixels.show();
  } else {
    //Wenn keine Bewegung erkannt wurde, dann sollen alle NeoPixel die gleiche Farbe haben.
    //löschen der derzeit angezeigten Farben
    pixels.clear();
    //Schleife von 0 bis 15,...
    for (int i = 0; i < NUMPIXELS; i++) {
      //Zuweisen der Farbe Rot zu einem NeoPixel
      pixels.setPixelColor(i, COLOR_RED);
    }
    //Anzeigen der Farben
    pixels.show();
  }
}
